/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { ADDON_CONFIG } from './../../../config/addonConfig.js';
import EaselManager from './../../../managers/EaselManager.js';
import PlayerManager from './../../../managers/Player/PlayerManager.js';
import { TAGS } from './../../../data.js';

const MAX_BORDERS = 4;
export const frameComp = {
    onPlayerInteract(eventData) {
        const { block, player } = eventData;
        if (player.isSneaking) return;
        const mainhand = PlayerManager.getItem(player, 'mainhand');
        if (mainhand?.hasTag('is_axe')) {
            const currentBorder = block.permutation.getState(`${ADDON_CONFIG.NAMESPACE}:border`);
            block.setPermutation(block.permutation.withState(`${ADDON_CONFIG.NAMESPACE}:border`, (currentBorder + 1) % MAX_BORDERS));
            player.playSound('use.wood');
            PlayerManager.decreaseDurability(player, mainhand);
            return;
        }
        const canvas = EaselManager.getCanvas(block);
        if (canvas) {
            EaselManager.openFrameForm(player, block, canvas);
        } else {
            if (mainhand?.hasTag(TAGS.PAINTING_ITEM)) EaselManager.addPainting(block, player, 'frame');
        }
    }
}