/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { world, ItemStack } from '@minecraft/server';
import PaintModeManager from './../../managers/PaintModeManager.js';
import { ADDON_CONFIG } from './../../config/addonConfig.js';
import { OBJECTIVES, initializePlayerScores } from './../../scores.js';
import { ITEMS, DYNAMIC_PROPERTY_IDS } from './../../data.js';

world.afterEvents.playerSpawn.subscribe((eventData) => {
    const { player, initialSpawn } = eventData;
    if (initialSpawn) initializePlayerScores(player);
    if (OBJECTIVES.ACTIONS?.getScore(player) > 0) PaintModeManager.resetPlayer(player, true);
    const isFirstLoad = player.getDynamicProperty(DYNAMIC_PROPERTY_IDS.IS_FIRST_LOAD);
    if (!isFirstLoad) {
        player.dimension.spawnItem(new ItemStack(ITEMS.GUIDE_BOOK), player.location);
        player.setDynamicProperty(DYNAMIC_PROPERTY_IDS.IS_FIRST_LOAD, true);
    }
});