/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { world, system } from '@minecraft/server';
import { ADDON_CONFIG } from './../../config/addonConfig.js';
import { updateCustomPalettes } from './../../config/colorsConfig.js';
import EaselManager from './../../managers/EaselManager.js';
import { TAGS, SCRIPTEVENT_IDS } from './../../data.js';

system.afterEvents.scriptEventReceive.subscribe(({ id, sourceEntity }) => {
    switch (id) {
        case SCRIPTEVENT_IDS.DROP_ITEM: {
            if (!sourceEntity?.matches({ families: [`${ADDON_CONFIG.NAMESPACE}.canvas`] })) return;
            const easel = sourceEntity.dimension.getBlock(sourceEntity.location);
            if (sourceEntity.hasTag(TAGS.IS_SAVED)) EaselManager.dropPainting(easel, sourceEntity);
            else EaselManager.deleteCanvas(easel, sourceEntity, null, true);
            break;
        }
        case SCRIPTEVENT_IDS.RESET_CUSTOM_PALETTES: { world.getDynamicPropertyIds().forEach((id) => { world.setDynamicProperty(id, ''); }); updateCustomPalettes(); break; }
        default: break;
    }
});