/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { world } from '@minecraft/server';
import { ADDON_CONFIG } from './../config/addonConfig';
import { easelComp, easelTickComp, frameComp, paintingCopierComp } from './custom_components/index.js';

const blockComponents = {
    'easel_component': easelComp,
    'easel_tick_component': easelTickComp,
    'frame_component': frameComp,
    'painting_copier_component': paintingCopierComp
};

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry, itemComponentRegistry }) => {
    for (const [identifier, component] of Object.entries(blockComponents)) {
        blockComponentRegistry.registerCustomComponent(ADDON_CONFIG.NAMESPACE + ':' + identifier, component);
    }
});