/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { ADDON_CONFIG } from './config/addonConfig.js';
import { PAINT_MODE_CONFIG } from './config/paintModeConfig.js';
import { OBJECTIVES } from './scores.js';

const GuideBook = {};
function _initializeForms() {
    for (let i = 0; i < 8; i++) {
        const form = new ActionFormData();
        switch (i) {
            case 0: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_0.title' })
                .body(ADDON_CONFIG.NAME + ' -§7 v' + ADDON_CONFIG.VERSION + '§r')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_1.title' }, 'textures/DynamicPaintings/ui/guide_book/page_1')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_2.title' }, 'textures/DynamicPaintings/ui/guide_book/page_2')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_3.title' }, 'textures/DynamicPaintings/ui/guide_book/page_3')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_4.title' }, 'textures/DynamicPaintings/ui/guide_book/page_4')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_5.title' }, 'textures/DynamicPaintings/ui/guide_book/page_5')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_6.title' }, 'textures/DynamicPaintings/ui/guide_book/page_6')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_7.title' }, 'textures/DynamicPaintings/ui/guide_book/page_7')
                .button({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.title' }, 'textures/ui/icon_setting');
                break;
            }
            
            case 1: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_1.title' })
                .body({
                    rawtext: [
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_1.body_0' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_1.body_1' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.recipe_item', with: ['1', '%item.dye.red.name']},
                    { text: '\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.recipe_item', with: ['1', '%item.dye.green.name']},
                    { text: '\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.recipe_item', with: ['1', '%item.dye.blue_new.name']},
                    { text: '\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.recipe_item', with: ['3', '%itemGroup.name.planks']},
                    { text: '\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.recipe_item', with: ['2', '%item.stick.name']},
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_1.body_2' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 2: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_2.title' })
                .body({
                    rawtext: [
                    { text: '§b' },
                    { translate: 'tile.dynamic_paintings.gst:artistic_table.name' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_2.body_0' },
                    { text: '\n\n§b' },
                    { translate: 'tile.dynamic_paintings.gst:easel.name' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_2.body_1' },
                    { text: '\n\n§b' },
                    { translate: 'tile.dynamic_paintings.gst:frame.name' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_2.body_2' },
                    { text: '\n\n§b' },
                    { translate: 'tile.dynamic_paintings.gst.painting_copier.name' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_2.body_3' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 3: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_3.title' })
                .body({
                    rawtext: [
                    { text: '§b' },
                    { translate: 'item.dynamic_paintings.gst.brush.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_0' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.palette.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_1' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.eyedropper.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_2' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.paint_bucket.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_3' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.shapes.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_4' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.exposure_tool.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_5' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.paint_remover.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_6' },
                    { text: '\n\n§b'},
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_7', with: ['%item.dynamic_paintings.gst.undo.item', '%item.dynamic_paintings.gst.redo.item'] },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_8' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst.canvas.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_9' },
                    { text: '\n\n§b'},
                    { translate: 'item.dynamic_paintings.gst:painting.item' },
                    { text: '\n§7' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_3.body_10' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 4: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_4.title' })
                .body({
                    rawtext: [
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_0' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_1' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_2' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_3' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_4' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_5' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_6', with: ['%item.dynamic_paintings.gst.brush.item', '%item.dynamic_paintings.gst.large_brush.item', '%item.dynamic_paintings.gst.paint_bucket.item'] },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_7', with: ['%item.dynamic_paintings.gst.palette.item'] },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_8' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_9' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_10' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_11' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_4.body_12' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 5: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_5.title' })
                .body({
                    rawtext: [
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_0' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_1' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_2' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_3' },
                    { text: '\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_4' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_5.body_5' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 6: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_6.title' })
                .body({
                    rawtext: [
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_6.body_0' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_6.body_1' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_6.body_2' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_6.body_3' },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
            
            case 7: {
                form.title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_7.title' })
                .body({
                    rawtext: [
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_7.body_0' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_7.body_1', with: ['%tile.dynamic_paintings.gst.painting_copier.name', '%tile.dynamic_paintings.gst:artistic_table.name'] },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_7.body_2' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_7.body_3' },
                    { text: '\n\n' },
                    { translate: 'ui.dynamic_paintings_gst.guide_book.page_7.body_4', with: ['%tile.dynamic_paintings.gst.painting_copier.name'] },
                    { text: '\n\n' }
                    ]
                });
                break;
            }
        }
        if (i > 0 && i < 7) form.button({ translate: 'ui.dynamic_paintings_gst.guide_book.next' }, 'textures/DynamicPaintings/ui/next');
        if (i > 0) form.button({ translate: 'gui.back' }, 'textures/DynamicPaintings/ui/return');
        GuideBook[i] = form;
    }
}
_initializeForms();
export function openGuideBookForm(player, form = 0) {
    if (!GuideBook[form]) _initializeForms();
    if (form === 8) {
        const modalForm = new ModalFormData().title({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.title' })
        .slider({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.slider_0'}, PAINT_MODE_CONFIG.STEP_COUNT.min, PAINT_MODE_CONFIG.STEP_COUNT.max, PAINT_MODE_CONFIG.STEP_COUNT.steps, PAINT_MODE_CONFIG.STEP_COUNT.defaultValue)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_0' }, PAINT_MODE_CONFIG.BRUSH_SOUND)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_1' }, PAINT_MODE_CONFIG.BUCKET_SOUND)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_2' }, PAINT_MODE_CONFIG.EYEDROPPER_SOUND)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_3' }, PAINT_MODE_CONFIG.ALLOW_PARTICLES)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_4' }, PAINT_MODE_CONFIG.HIDE_ITEM_TEXT)
        .toggle({ translate: 'ui.dynamic_paintings_gst.guide_book.page_8.toggle_5' }, PAINT_MODE_CONFIG.HIDE_CROSSHAIR)
        .submitButton({ translate: 'ui.dynamic_paintings_gst.confirm_button' })
        .show(player).then((e) => {
            if (e.canceled) return;
            PAINT_MODE_CONFIG.STEP_COUNT.defaultValue = e.formValues[0];
            PAINT_MODE_CONFIG.BRUSH_SOUND = e.formValues[1];
            PAINT_MODE_CONFIG.BUCKET_SOUND = e.formValues[2];
            PAINT_MODE_CONFIG.EYEDROPPER_SOUND = e.formValues[3];
            PAINT_MODE_CONFIG.ALLOW_PARTICLES = e.formValues[4];
            PAINT_MODE_CONFIG.HIDE_ITEM_TEXT = e.formValues[5];
            PAINT_MODE_CONFIG.HIDE_CROSSHAIR = e.formValues[6];
        });
    } else {
        GuideBook[form].show(player).then((e) => {
            if (e.canceled) return;
            if (form === 0) {
                openGuideBookForm(player, e.selection + 1);
            } else {
                openGuideBookForm(player, form < 7 && e.selection === 0 ? form + 1 : 0);
            }
        });
    }
}