/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { EntityRideableComponent } from '@minecraft/server';
import { ADDON_CONFIG } from './../../../config/addonConfig.js';
import { ENTITIES, CARDINAL_ROTATIONS } from './../../../data.js';

function getTeleportPoint(cardinalDirection = 'north') {
    return {
        'north': { x: 0, y: 0, z: -1.25 },
        'east': { x: 1.25, y: 0, z: 0 },
        'south': { x: 0, y: 0, z: 1.25 },
        'west': { x: -1.25, y: 0, z: 0 }
    }[cardinalDirection];
}
function spawnPlayerControl(easel, player) {
    if (!easel || !player) return;
    const cardinalDirection = easel.permutation.getState('minecraft:cardinal_direction');
    const loc = getTeleportPoint(cardinalDirection);
    const playerControl = easel.dimension.spawnEntity(ENTITIES.PLAYER_CONTROL, { x: easel.x + 0.5 + loc.x, y: easel.y + loc.y, z: easel.z + 0.5 + loc.z });
    playerControl.setRotation({ x: 0, y: CARDINAL_ROTATIONS[cardinalDirection] });
    playerControl.triggerEvent(ADDON_CONFIG.NAMESPACE + ':' + cardinalDirection + '_rotation');
    playerControl.getComponent(EntityRideableComponent.componentId)?.addRider(player);
    return playerControl;
}
export { spawnPlayerControl }