/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { ADDON_CONFIG } from './../../../config/addonConfig.js';
import { SHAPES } from './../../../config/shapesConfig.js';
import { paintPixel } from './pixelFunctions.js';
import { ENTITIES } from './../../../data.js';

function createShape(player, canvasPixels, colorToPaint = 0, type, pointMin, pointMax, hollow = false) {
    const shapePixels = SHAPES[type]({ min: pointMin, max: pointMax, hollow: hollow });
    if (!shapePixels) return;
    for (const pixel of shapePixels) {
        paintPixel(player, pixel, canvasPixels, colorToPaint, 1, false, false);
    }
}
function spawnShapeBox(easel, cardinalDirection) {
    const shapeBox = easel.dimension.spawnEntity(ENTITIES.SHAPE_BOX, easel.bottomCenter());
    shapeBox.triggerEvent(ADDON_CONFIG.NAMESPACE + ':spawn_' + cardinalDirection);
    return shapeBox;
}
export { createShape, spawnShapeBox }