/**
* Copyright © [2024] [GST378]. All rights reserved.
* Personal use only. Modifications and redistribution are prohibited.
* See LICENSE file for details.
*/
import { world } from '@minecraft/server';
import { ADDON_CONFIG } from './config/addonConfig.js';

export const OBJECTIVES = {
    ACTIONS: world.scoreboard.getObjective(`${ADDON_CONFIG.NAMESPACE}:score_actions`) ?? world.scoreboard.addObjective(`${ADDON_CONFIG.NAMESPACE}:score_actions`),
    COLOR_RGB: world.scoreboard.getObjective(`${ADDON_CONFIG.NAMESPACE}:color_rgb`) ?? world.scoreboard.addObjective(`${ADDON_CONFIG.NAMESPACE}:color_rgb`)
}

const scoreActions = {
    'stop_paint_mode': 0,
    'start_paint_mode': 1,
    //
    'brush': 10,
    'large_brush': 11,
    //
    'paint_remover': 20,
    'paint_bucket': 21,
    'eyedropper': 22,
    'palette': 23,
    'exposure_tool': 24,
    //
    'update_steps': 50,
    'undo': 51,
    'redo': 52,
    //
    'shape_step_0': 100,
    'shape_step_1': 101,
    'shape_step_2': 102
};
export function getPaintingAction(player) { return Object.entries(scoreActions).find(([key, value]) => value === OBJECTIVES.ACTIONS?.getScore(player))?.[0] ?? 'stop_paint_mode'; }
export function setActionScore(player, action) { OBJECTIVES.ACTIONS.setScore(player, scoreActions[action]); }
export function initializePlayerScores(player) {
    if (!player.isValid()) return;
    for (const obj of Object.values(OBJECTIVES)) { obj.setScore(player, 0) }
}